(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngx-context', ['exports', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-context'] = {}, global.ng.core, global.rxjs, global.rxjs.operators));
}(this, (function (exports, core, rxjs, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    function isSubscribableOrPromise(obj) {
        return obj instanceof rxjs.Observable || obj instanceof rxjs.Subject || obj instanceof Promise;
    }
    function parseKeys(input) {
        return (Array.isArray(input) ? input : input.split(/\s+/)).filter(function (key) { return key; });
    }

    var ContextProviderComponent = /** @class */ (function () {
        function ContextProviderComponent(source) {
            this.source = source;
            this.initialized = false;
            this._contextMap = {};
            this._provide = '';
            this.provided = new Map();
            this.change$ = new rxjs.ReplaySubject(1);
            this.reset$ = new rxjs.Subject();
        }
        Object.defineProperty(ContextProviderComponent.prototype, "contextMap", {
            get: function () {
                return this._contextMap;
            },
            set: function (map) {
                this._contextMap = map || {};
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ContextProviderComponent.prototype, "provide", {
            get: function () {
                return this._provide;
            },
            set: function (value) {
                this._provide = value || '';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ContextProviderComponent.prototype, "component", {
            get: function () {
                var _a;
                return ((_a = this.source['_view']) === null || _a === void 0 ? void 0 : _a.component) || this.source['context'];
            },
            enumerable: false,
            configurable: true
        });
        ContextProviderComponent.prototype.init = function () {
            var _this = this;
            setTimeout(function () {
                var THIS = _this;
                var context = new Map();
                var provided = parseKeys(_this.provide).filter(function (key) { return key && key in _this.component; });
                provided.forEach(function (key) {
                    if (isSubscribableOrPromise(_this.component[key])) {
                        _this.change$.next(key);
                        return;
                    }
                    var propertyDescriptor = Object.getOwnPropertyDescriptor(_this.component, key) ||
                        Object.getOwnPropertyDescriptor(_this.component.__proto__, key);
                    _this.provided.set(key, propertyDescriptor);
                    var value = propertyDescriptor.value, writable = propertyDescriptor.writable, getter = propertyDescriptor.get, setter = propertyDescriptor.set, prop = __rest(propertyDescriptor, ["value", "writable", "get", "set"]);
                    Object.defineProperty(_this.component, key, Object.assign(Object.assign({}, prop), { get: getter
                            ? function () {
                                return getter.call(this);
                            }
                            : function () {
                                return context.get(key);
                            }, set: setter
                            ? function () {
                                setter.apply(this, arguments);
                                THIS.change$.next(key);
                            }
                            : function (newValue) {
                                context.set(key, newValue);
                                THIS.change$.next(key);
                            } }));
                    _this.component[key] = value || _this.component[key];
                });
            }, 0);
        };
        ContextProviderComponent.prototype.reset = function () {
            var _this = this;
            this.provided.forEach(function (propertyDescriptor, key) {
                var value = _this.component[key];
                Object.defineProperty(_this.component, key, propertyDescriptor);
                _this.component[key] = value;
            });
            this.provided.clear();
            this.change$.next('');
            this.reset$.next();
        };
        ContextProviderComponent.prototype.ngOnChanges = function () {
            if (this.initialized) {
                this.reset();
                if (this.source)
                    this.init();
            }
        };
        ContextProviderComponent.prototype.ngOnInit = function () {
            this.initialized = true;
            this.ngOnChanges();
        };
        return ContextProviderComponent;
    }());
    ContextProviderComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'context-provider',
                    template: '<ng-content></ng-content>',
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None
                },] }
    ];
    ContextProviderComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
    ]; };
    ContextProviderComponent.propDecorators = {
        contextMap: [{ type: core.Input }],
        provide: [{ type: core.Input }]
    };

    var AbstractContextConsumer = /** @class */ (function () {
        function AbstractContextConsumer(provider, target) {
            this.provider = provider;
            this.target = target;
            this.destroy$ = new rxjs.Subject();
            this._contextMap = {};
            this._consume = '';
            this.consumed = new Map();
        }
        Object.defineProperty(AbstractContextConsumer.prototype, "contextMap", {
            get: function () {
                return this._contextMap;
            },
            set: function (map) {
                this._contextMap = map || {};
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AbstractContextConsumer.prototype, "consume", {
            get: function () {
                return this._consume;
            },
            set: function (consume) {
                this._consume = consume || '';
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AbstractContextConsumer.prototype, "component", {
            get: function () {
                var _a;
                return ((_a = this.target['_view']) === null || _a === void 0 ? void 0 : _a.component) || this.target['context'];
            },
            enumerable: false,
            configurable: true
        });
        AbstractContextConsumer.prototype.init = function () {
            var _this = this;
            var consumed = parseKeys(this.consume);
            this.provider.reset$
                .pipe(operators.takeUntil(this.destroy$))
                .subscribe(function () { return _this.ngOnChanges(); });
            if (this.provider.provide.length)
                this.provider.change$
                    .pipe(operators.takeUntil(this.destroy$), operators.startWith.apply(void 0, __spreadArray([], __read(Array.from(this.provider.provided.keys())))), operators.filter(function (key) { return !!key; }))
                    .subscribe(function (providerKey) { return _this.syncProperties(consumed, providerKey); });
        };
        AbstractContextConsumer.prototype.reset = function () {
            var _this = this;
            this.consumed.forEach(function (value, key) {
                _this.component[key] = value;
            });
            this.consumed.clear();
        };
        AbstractContextConsumer.prototype.syncProperties = function (consumed, providerKey) {
            var key = this.provider.contextMap[providerKey] || providerKey;
            key = this.contextMap[key] || key;
            if (consumed.length && consumed.indexOf(key) < 0)
                return;
            if (!this.consumed.has(key))
                this.consumed.set(key, this.component[key]);
            this.component[key] = this.provider.component[providerKey];
            this.target.markForCheck();
        };
        AbstractContextConsumer.prototype.ngOnChanges = function () {
            if (this.initialized) {
                this.destroy$.next();
                this.reset();
                if (this.target && this.provider)
                    this.init();
            }
        };
        AbstractContextConsumer.prototype.ngOnDestroy = function () {
            this.destroy$.next();
        };
        AbstractContextConsumer.prototype.ngOnInit = function () {
            this.initialized = true;
            this.ngOnChanges();
        };
        return AbstractContextConsumer;
    }());
    AbstractContextConsumer.decorators = [
        { type: core.Directive }
    ];
    AbstractContextConsumer.ctorParameters = function () { return [
        { type: ContextProviderComponent },
        { type: core.ChangeDetectorRef }
    ]; };
    AbstractContextConsumer.propDecorators = {
        contextMap: [{ type: core.Input }],
        consume: [{ type: core.Input }]
    };

    var ContextConsumerComponent = /** @class */ (function (_super) {
        __extends(ContextConsumerComponent, _super);
        function ContextConsumerComponent(providerComponent, parent) {
            return _super.call(this, providerComponent, parent) || this;
        }
        return ContextConsumerComponent;
    }(AbstractContextConsumer));
    ContextConsumerComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'context-consumer',
                    template: '',
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None
                },] }
    ];
    ContextConsumerComponent.ctorParameters = function () { return [
        { type: ContextProviderComponent, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] },
        { type: core.ChangeDetectorRef, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
    ]; };

    var ContextConsumerDirective = /** @class */ (function (_super) {
        __extends(ContextConsumerDirective, _super);
        function ContextConsumerDirective(providerComponent, host) {
            return _super.call(this, providerComponent, host) || this;
        }
        Object.defineProperty(ContextConsumerDirective.prototype, "consume", {
            get: function () {
                return this._consume;
            },
            set: function (consume) {
                this._consume = consume || '';
            },
            enumerable: false,
            configurable: true
        });
        return ContextConsumerDirective;
    }(AbstractContextConsumer));
    ContextConsumerDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[contextConsumer]',
                },] }
    ];
    ContextConsumerDirective.ctorParameters = function () { return [
        { type: ContextProviderComponent, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] },
        { type: core.ChangeDetectorRef, decorators: [{ type: core.Optional }, { type: core.Host }] }
    ]; };
    ContextConsumerDirective.propDecorators = {
        consume: [{ type: core.Input, args: ['contextConsumer',] }]
    };

    var Context = /** @class */ (function () {
        function Context() {
            this.$implicit = {};
        }
        return Context;
    }());
    var ContextDisposerDirective = /** @class */ (function () {
        function ContextDisposerDirective(tempRef, vcRef, provider) {
            this.tempRef = tempRef;
            this.vcRef = vcRef;
            this.provider = provider;
            this.destroy$ = new rxjs.Subject();
            this._dispose = '';
        }
        Object.defineProperty(ContextDisposerDirective.prototype, "dispose", {
            get: function () {
                return this._dispose;
            },
            set: function (dispose) {
                this._dispose = dispose || '';
            },
            enumerable: false,
            configurable: true
        });
        ContextDisposerDirective.prototype.init = function () {
            var _this = this;
            var disposed = parseKeys(this.dispose);
            this.provider.reset$
                .pipe(operators.takeUntil(this.destroy$))
                .subscribe(function () { return _this.ngOnChanges(); });
            if (this.provider.provide.length)
                this.provider.change$
                    .pipe(operators.takeUntil(this.destroy$), operators.startWith.apply(void 0, __spreadArray([], __read(Array.from(this.provider.provided.keys())))), operators.filter(function (key) { return !!key; }))
                    .subscribe(function (providerKey) { return _this.syncProperties(disposed, providerKey); });
        };
        ContextDisposerDirective.prototype.reset = function () {
            this.view = this.vcRef.createEmbeddedView(this.tempRef, new Context());
        };
        ContextDisposerDirective.prototype.syncProperties = function (disposed, providerKey) {
            var key = this.provider.contextMap[providerKey] || providerKey;
            if (disposed.length && disposed.indexOf(key) < 0)
                return;
            var value = this.provider.component[providerKey];
            this.view.context.$implicit[key] = value;
            this.view.context[key] = value;
            this.view.markForCheck();
        };
        ContextDisposerDirective.prototype.ngOnChanges = function () {
            this.ngOnDestroy();
            this.reset();
            if (this.provider && this.tempRef && this.vcRef)
                this.init();
        };
        ContextDisposerDirective.prototype.ngOnDestroy = function () {
            this.destroy$.next();
            if (this.view)
                this.vcRef.clear();
        };
        return ContextDisposerDirective;
    }());
    ContextDisposerDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[contextDisposer]',
                },] }
    ];
    ContextDisposerDirective.ctorParameters = function () { return [
        { type: core.TemplateRef, decorators: [{ type: core.Optional }] },
        { type: core.ViewContainerRef, decorators: [{ type: core.Optional }] },
        { type: ContextProviderComponent, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
    ]; };
    ContextDisposerDirective.propDecorators = {
        dispose: [{ type: core.Input, args: ['contextDisposer',] }]
    };

    var NgxContextModule = /** @class */ (function () {
        function NgxContextModule() {
        }
        return NgxContextModule;
    }());
    NgxContextModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        ContextConsumerComponent,
                        ContextConsumerDirective,
                        ContextDisposerDirective,
                        ContextProviderComponent,
                    ],
                    exports: [
                        ContextConsumerComponent,
                        ContextConsumerDirective,
                        ContextDisposerDirective,
                        ContextProviderComponent,
                    ],
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.ContextConsumerComponent = ContextConsumerComponent;
    exports.ContextConsumerDirective = ContextConsumerDirective;
    exports.ContextDisposerDirective = ContextDisposerDirective;
    exports.ContextProviderComponent = ContextProviderComponent;
    exports.NgxContextModule = NgxContextModule;
    exports.ɵa = AbstractContextConsumer;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-context.umd.js.map
